/*
 * @file name: lamp_control.h
 * @Descripttion: 
 * @Author: zgw
 * @email: liang.zhang@tuya.com
 * @Copyright: HANGZHOU TUYA INFORMATION TECHNOLOGY CO.,LTD
 * @Company: http://www.tuya.com
 * @Date: 2021-03-01 10:44:58
 * @LastEditors: zgw
 * @LastEditTime: 2021-04-22 16:07:12
 */
#ifndef __lamp_CONTROL_H__
#define __lamp_CONTROL_H__

#include "uni_log.h"
#include "tuya_cloud_error_code.h"


#define DISTANCE_THRESHOLD                           10
#define LIGHT_INTENSITY_THRESHOLD                    25
#define SIT_REMIND_THRESHOLD                         6

typedef enum {
    white,
    medium,
    warm
}LIGHT_MODE;


typedef struct {
    BOOL_T Lamp_delay_off;
    BOOL_T Lamp_switch;
    LIGHT_MODE Light_mode;
    BOOL_T Sit_remind;
    BOOL_T Auto_light;
    BOOL_T Low_pow_alarm;
    BOOL_T Silent_mode;
    BOOL_T Radar_sensor;
    USHORT_T Human_distance;
    UCHAR_T time_hour;
    UCHAR_T time_min;
    UCHAR_T Battery_remain;
    UCHAR_T Light_intensity;
    UCHAR_T Wifi_state;
    UCHAR_T User_timer;
    UCHAR_T Light_level;
}LAMP_CTRL_DATA_T;

/********************************************************************************
 * FUNCTION:       plant_device_init
 * DESCRIPTION:    device initialization
 * INPUT:          none
 * OUTPUT:         none
 * RETURN:         none
 * OTHERS:         none
 * HISTORY:        2021-01-12
 *******************************************************************************/
VOID lamp_device_init(VOID);

/********************************************************************************
 * FUNCTION:       plant_get_adc_sensor_data
 * DESCRIPTION:    Get ADC sensor data
 * INPUT:          none
 * OUTPUT:         none
 * RETURN:         none
 * OTHERS:         none
 * HISTORY:        2021-01-12
 *******************************************************************************/
VOID lamp_get_sensor_data(VOID);

/********************************************************************************
 * FUNCTION:       plant_ctrl_handle
 * DESCRIPTION:    sensor data deal handle
 * INPUT:          none
 * OUTPUT:         none
 * RETURN:         none
 * OTHERS:         none
 * HISTORY:        2021-01-12
 *******************************************************************************/
VOID lamp_ctrl_handle(VOID);

/********************************************************************************
 * FUNCTION:       plant_ctrl_all_off
 * DESCRIPTION:    Close all control components
 * INPUT:          none
 * OUTPUT:         none
 * RETURN:         none
 * OTHERS:         none
 * HISTORY:        2021-01-12
 *******************************************************************************/
VOID lamp_ctrl_all_off(VOID);

VOID lamp_key_poll(VOID);

VOID lamp_display_poll(VOID);
#endif