/*
 * @file name: sh1106.h
 * @Descripttion: 
 * @Author: zgw
 * @email: liang.zhang@tuya.com
 * @Copyright: HANGZHOU TUYA INFORMATION TECHNOLOGY CO.,LTD
 * @Company: http://www.tuya.com
 * @Date: 2021-03-10 10:46:14
 * @LastEditors: zgw
 * @LastEditTime: 2021-03-12 10:45:09
 */

#ifndef __SH1106_H__
#define __SH1106_H__

#include "uni_log.h"
#include "tuya_cloud_error_code.h"

typedef struct 
{
    UCHAR_T SDA_PIN;            ///< SDA pin
    UCHAR_T SCL_PIN;            ///< SCL pin 
}sh1106_init_t;

typedef enum {
    clear,
    full
}C_F_CMD_T;



UCHAR_T tuya_sh1106_init(sh1106_init_t* param);

VOID tuya_sh1106_clear(VOID);
VOID tuya_sh1106_full(VOID);
VOID tuya_sh1106_display(VOID);

VOID tuya_sh1106_on(VOID);
VOID tuya_sh1106_off(VOID);

VOID tuya_sh1106_gram_point_set(UCHAR_T x, UCHAR_T y, CONST UCHAR_T *ptr_pic);
#endif